#include <stdlib.h>
#include <stdio.h>
#include <string.h>
typedef struct _nodoNombre{
	char nombre[20];
	struct _nodoNombre * sig;
} nodoNombre;

typedef struct _nodoRecord {
	nodoNombre * enteros;
	nodoNombre * cadenas;
} nodoRecord; 

typedef struct _nodoDato {
	char nombre[20];
	char tipo;
	union{
		int valorInteger;
		char * valorString;
		struct{
			nodoRecord * registro;
			int * valoresInteger;
			char * * valoresString;
		} valorRecord;
	} valores;
	struct _nodoDato * sig;
} nodoDato;
nodoDato * tablaDatos;

void insertarDato(nodoDato * x){
	x->sig = tablaDatos;
	tablaDatos = x;
}

nodoDato * buscarDato(char *nombre){
  nodoDato * t = tablaDatos;
  while( (t != NULL) && (strcmp(nombre, t->nombre)) )
      t = t->sig;
  return (t);
}

int buscarIntegerEnRecord(char * nombre, nodoRecord* registro){
	return buscarNombreEnListaDeNombres(nombre, registro->enteros);
}
int buscarStringEnRecord(char * nombre, nodoRecord* registro){
	return buscarNombreEnListaDeNombres(nombre, registro->cadenas);
}
int buscarNombreEnListaDeNombres(char * nombre, nodoNombre * lista){
  int pos = 0;
  while( (lista != NULL) && (strcmp(nombre, lista->nombre)) ){
  		pos++;
      lista = lista->sig;
  }
  return (lista==NULL)?-1:pos;
}

void comprobarDatos(){
  nodoDato * t = tablaDatos;
  while(t != NULL) {
      printf("%s\n", t->nombre);
      printf("%c\n", t->tipo);
      t = t->sig;
    }
}
